---
 Makefile.util.def                 |   10 +++++-----
 configure.ac                      |    1 +
 grub-core/Makefile.core.def       |   14 +++++---------
 grub-core/osdep/unix/emuconsole.c |    5 +++--
 4 files changed, 14 insertions(+), 16 deletions(-)

--- a/Makefile.util.def
+++ b/Makefile.util.def
@@ -350,7 +350,7 @@ program = {
   ldadd = grub-core/gnulib/libgnu.a;
   ldadd = '$(LIBINTL) $(LIBDEVMAPPER) $(LIBUTIL) $(LIBZFS) $(LIBNVPAIR) $(LIBGEOM)';
   cppflags = '-DGRUB_SETUP_FUNC=grub_util_bios_setup';
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 program = {
@@ -371,7 +371,7 @@ program = {
   ldadd = grub-core/gnulib/libgnu.a;
   ldadd = '$(LIBINTL) $(LIBDEVMAPPER) $(LIBUTIL) $(LIBZFS) $(LIBNVPAIR) $(LIBGEOM)';
   cppflags = '-DGRUB_SETUP_FUNC=grub_util_sparc_setup';
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 program = {
@@ -387,7 +387,7 @@ program = {
   ldadd = libgrubkern.a;
   ldadd = grub-core/gnulib/libgnu.a;
   ldadd = '$(LIBINTL) $(LIBDEVMAPPER) $(LIBUTIL) $(LIBGEOM)';
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 program = {
@@ -418,7 +418,7 @@ program = {
   ldadd = libgrubkern.a;
   ldadd = grub-core/gnulib/libgnu.a;
   ldadd = '$(LIBINTL) $(LIBDEVMAPPER) $(LIBZFS) $(LIBNVPAIR) $(LIBGEOM)';
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 data = {
@@ -1323,7 +1323,7 @@ program = {
   ldadd = libgrubkern.a;
   ldadd = grub-core/gnulib/libgnu.a;
   ldadd = '$(LIBINTL) $(LIBDEVMAPPER) $(LIBZFS) $(LIBNVPAIR) $(LIBGEOM)';
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 program = {
--- a/grub-core/Makefile.core.def
+++ b/grub-core/Makefile.core.def
@@ -1076,7 +1076,7 @@ module = {
 module = {
   name = videotest;
   common = commands/videotest.c;
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 module = {
@@ -1490,7 +1490,7 @@ module = {
   common = gfxmenu/gui_progress_bar.c;
   common = gfxmenu/gui_util.c;
   common = gfxmenu/gui_string_util.c;
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 module = {
@@ -1870,13 +1870,13 @@ module = {
   name = gfxterm;
   common = term/gfxterm.c;
   enable = videomodules;
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 module = {
   name = gfxterm_background;
   common = term/gfxterm_background.c;
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 module = {
@@ -1989,9 +1989,7 @@ module = {
   enable = i386_pc;
   enable = i386_efi;
   enable = x86_64_efi;
-  enable = emu;
   enable = xen;
-  emu_condition = COND_NOT_s390x;
 };
 
 module = {
@@ -2007,7 +2005,7 @@ module = {
 module = {
   name = gfxterm_menu;
   common = tests/gfxterm_menu.c;
-  emu_condition = COND_NOT_s390x;
+  emu_condition = COND_NOT_emu;
 };
 
 module = {
@@ -2158,9 +2156,7 @@ module = {
   enable = i386_pc;
   enable = i386_efi;
   enable = x86_64_efi;
-  enable = emu;
   enable = xen;
-  emu_condition = COND_NOT_s390x;
 };
 
 module = {
--- a/configure.ac
+++ b/configure.ac
@@ -1652,6 +1652,7 @@ AC_SUBST(BUILD_LIBM)
 #
 
 AM_CONDITIONAL([COND_emu], [test x$platform = xemu])
+AM_CONDITIONAL([COND_NOT_emu], [test x$platform != xemu])
 AM_CONDITIONAL([COND_clang], [test x$grub_cv_cc_target_clang = xyes])
 AM_CONDITIONAL([COND_i386_pc], [test x$target_cpu = xi386 -a x$platform = xpc])
 AM_CONDITIONAL([COND_i386_efi], [test x$target_cpu = xi386 -a x$platform = xefi])
--- a/grub-core/osdep/unix/emuconsole.c
+++ b/grub-core/osdep/unix/emuconsole.c
@@ -50,13 +50,12 @@ static struct termios new_tty;
 static int console_mode = 0;
 
 #define MAX_LEN 1023
-#if defined(__s390x__)
+
 static int
 dummy (void)
 {
   return 0;
 }
-#endif
 #if 0
 static char msg[MAX_LEN+1];
 static  void
@@ -128,6 +127,7 @@ readkey (struct grub_term_input *term)
   return -1;
 }
 
+#if defined(__s390x__)
 #define NO_KEY	((grub_uint8_t)-1)
 static int
 readkey_dumb (struct grub_term_input *term)
@@ -158,6 +158,7 @@ readkey_dumb (struct grub_term_input *te
     p = c;
   return c;
 }
+#endif
 
 static void
 grub_dumb_putchar (struct grub_term_output *term,